#!/usr/bin/perl
##
##  sendudp.cgi -- send UDP datagram to specified IP address, then
##      call mouse.html back to complete loop
##
## modified 4July19 to match UDP Joystick output. That means 16-byte packets
## with four numbers ranging from 1000 to 2000 with 1500 meaning control is in
## neutral position. I'll make a touch at the center bottom be that neutral place,
## and center top be 15002000 and the left top corner be 10002000.

use strict;
my $coord_max=800;  ## use variable in case size of picture and thus range of coord changes
my $speed_max=999;
use IO::Socket::INET;
use CGI qw(:standard escapeHTML);  # CGI.pm simplifies HTML output
my $filename="/var/www/cgi-bin/datafiles/iptable";

$ENV{'PATH'} = '/bin:/usr/bin';
delete @ENV{'IFS', 'CDPATH', 'ENV', 'BASH_ENV'};
my $path = $ENV{'PATH'};       # $path now NOT tainted

# find the ip of the robot to control from the ip address using this page
dbmopen(my %FRED, "$filename", 0644); # open %FRED onto mydatabase
my $key= $ENV{REMOTE_ADDR};
 my $targetIP = $FRED{$key};
 dbmclose(%FRED);

# Send html that just jumps back to mouse screen on same web server after 0 sec
# Change 0 to a longer time to see targetIP for debugging
print header;
print "<meta http-equiv=\"Refresh\" content=\"0; url=http://$ENV{SERVER_ADDR}/mouse\" />\n";
print start_html;
print p,("you are controlling ",$targetIP);
print end_html;

my @splits = split(',',$ENV{QUERY_STRING});
my $x = $splits[0];
my $y = $splits[1];
# range of x and y is 0-800 aka coord_max, need to adjust range to 1000-2000. To do that,
# I need multiply by 1000/800 and add 1000.

# printf ("splits=%03d,%03d", $x ,$y);

my $x2 = ($speed_max/$coord_max)*$x+1000;
my $y2 = ($speed_max/$coord_max)*($coord_max-$y)+1000;

# printf ("sending %03d,%03d", $x2 ,$y2);

my $sock = new IO::Socket::INET(PeerAddr => $targetIP,
                PeerPort => 4949,
                Proto => 'udp', Timeout => 1);
printf $sock ("%04d%04d15001500", $x2,$y2);

# The logic for converting touch coordinates and/or joystick positions
# now moved to the esp8266 application from here. This script now just
# translates then relays positions.
# The first coordinate received (my $x) is the x coordinate on a two-dimensional
# screen map, left to right. If the picture is 800 wide, like mine, the center
# is 400. The second coordinate received (my $y) is a y coordinate, zero at the
# top of the screen and 800 at the bottom.
# The output I want is a translation of these to a range of 1000-2000 with 1500
# meaning control is in neutral position. I'll make a touch at the picture middle
# be that neutral place, so 400,400 translates to 15001500 and center top be aka
# 400,0 translates to 15002000 and the left top corner is 0,0 and translates to
# be 10002000.
